/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Plot einer Funktion y = f(x) mittels '*'-Zeichen 
 * im Intervall von a bis b mit n Schritten,
 * Berechnung der Zeichenposition direkt aus dem Funktionswert,
 * Erstellung einer Zeile mittels eigener Methode
 * z. B. a = -2.0, b = 2.0, n = 30 
 */
public class FunktionPlotV3 {
    public static void main(String[] args) {

        double a  = -2.0;
        double b  = -2.0;

        /********/
        int    n  = 30;                 // Anzahl der Schritte
        /********/

        double x;
 
        // Berechnung von dx aus n:
        /***********************/        
        double dx = (b - a) / n ;       // automatische Typumwandlung für n: int -> double
        /***********************/        

        x = a;
        // *solange* x innerhalb des Intervalls liegt:    
        while (x <= b) {

            double y = f(x);            

            // Zeichenposition entspricht dem y-Wert:
            /*************************/             
            int pos = (int) ( y / dx ); // explizite Typumwandlung double -> int
            /*************************/             

            // Erstellung einer Zeile 
            /***************************************/        
            String s = positionszeichen(pos, 2, '*');
            /***************************************/        

            System.out.println(s);

            x = x + dx;                 // nächster x-Wert
        }
 
    }

    /**
    * Erzeugung einer Zeichenkette, die aus n Leerzeichen, gefolgt von einem Zeichen ch, besteht
    */
    private static String positionszeichen(int n, int k, char c) {

        String s = ""; // mittels dieser lokalen Variablen wird das Ergebnis aufgebaut

        // n*k-maliges Anfügen eines Leerzeichens
        for(int i = 0; i < k*n; i++)
            s += ' ';

        // abschließendes Anfügen des Zeichens ch
        s += c;

        return s;   // Rückgabe der fertigen Zeichenkette
    }

    /**
    * Berechnung der Funktion -0.01*x^5 + 0.08*x^4 - 0.26*x^3 - 0.31*x^2 + 1.4*x + 2.36
    */ 
    private static double f(double x) {
        return -0.01*x*x*x*x*x + 0.08*x*x*x*x - 0.26*x*x*x - 0.31*x*x + 1.4*x + 2.36;
    }

}
