/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Verarbeitung von Arrays
 */
public class ArrayExamples2 {
    public static void main(String[] args) {

        // Arrays deklarieren und erzeugen
        int[] a = new int[10];
        int[] b = new int[10];
        int[] c = new int[10];

        // Array a initialisieren
        for (int i = 0; i < 10; i++)    // elementweise Zuweisung von Werten:
            a[i] = i;                   // dem Element a[i] wird als Wert sein Index (i) zugewiesen
            
        // Array kopieren: Werte der Elemente   
        for (int i = 0; i < 10; i++)    // Kopieren der Werte der Elemente von a 
            b[i] = a[i];                // in die entsprechenden Elemente von b


        // mittels length:
        // for (int i = 0; i < a.length; i++) 
        //     a[i] = i;

        // for (int i = 0; i < a.length; i++) 
        //     b[i] = a[i];


        // Array a ausgeben
        for (int i = 0; i < b.length; i++) 
            System.out.println("a[" + i + "] : "+b[i]);
        System.out.println();       // Abschluss mit Leerzeile

        // Array b ausgeben, mittels Methode
        ausgabe ( b );

        // Array a nach Array c kopieren
        kopiere( a, c );            // Array c wird verändert! 
        ausgabe( c );

        // neues Array d erzeugen, das eine Kopie von a ist
        int[] d = kopie( a );
        ausgabe( d );

        // Elemente von a quadrieren
        quadriere( a );             // Array a wird verändert! 
        ausgabe( a );

        // neues Array e erzeugen, das die quadrierten Elemente von a enthält
        int[] e = quadrat( a );
        ausgabe( e );

    }

    /**
    * Ausgabe aller Elemente eines Arrays.
    */
    private static void ausgabe(int[] a) {

        for (int i = 0; i < a.length; i++) 
            System.out.println("[" + i + "]: " + a[i]);

        System.out.println();               // Abschluss mit Leerzeile
    }

    /**
    * Kopieren eines Arrays.
    * Das Array, das an Stelle von b übergeben wird, wird verändert!
    */
    private static void kopiere(int[] a, int[] b) {
        for (int i = 0; i < a.length; i++)  // Kopieren der Werte der Elemente von a 
            b[i] = a[i];                    // in die entsprechenden Elemente von b
    }

    /**
    * Kopieren eines Arrays.
    * Liefert neues Array, das eine Kopie des übergebenen Arrays ist.
    */
    private static int[] kopie(int[] a) {
        int[] r = new int[a.length];        // neues Array r derselben Länge wie a
        
        for (int i = 0; i < a.length; i++)  // Kopieren der Werte der Elemente von a
            r[i] = a[i];                    // in die entsprechenden Elemente von r

        return r;                           // r wird als Ergebnis zurückgegeben
    }

    /**
    * Elementweises Quadrieren eines Arrays.
    * Das übergebene Array wird verändert!
    */
    private static void quadriere(int[] a) {

        for (int i = 0; i < a.length; i++)  
            a[i] = a[i] * a[i];             // Element i wird quadriert
    }

    /**
    * Elementweises Quadrieren eines Arrays.
    * Liefert ein neues Array, das die Quadrate des übergebenen Arrays enthält.
    */
    private static int[] quadrat(int[] a) {
        int[] r = new int[a.length];        // neues Array derselben Länge wie a

        for (int i=0; i< a.length; i++)     // den Elementen von r werden die Quadrate  
            r[i] = a[i] * a[i];             // der entsprechenden Elemente von a zugewiesen

        return r;                           // r wird als Ergebnis zurückgegeben
    }

}
