/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Verarbeitung von String-Arrays
 */
public class ArrayExamples3 {
    public static void main(String[] s1rgs) {

        // Arrays deklarieren und erzeugen
        String[] s1 = new String[10];
        String[] s2 = new String[10];
        String[] s3 = new String[10];

        // Array s1 initialisieren
        for (int i = 0; i < 10; i++)            // elementweise Zuweisung von Werten:
            s1[i] = "(element " + i + ")"; 
            
        // Array kopieren: Werte der Elemente   
        for (int i = 0; i < 10; i++)            // Kopieren der Werte der Elemente von s1
            s2[i] = s1[i];                      // in die entsprechenden Elemente von s2


        // mittels length:
        // for (int i = 0; i < s1.length; i++) 
        //     s1[i] = i;

        // for (int i = 0; i < s1.length; i++) 
        //     s2[i] = s1[i];


        // Array s2 ausgeben
        for (int i = 0; i < s2.length; i++) 
            System.out.println("s2[" + i + "] : "+s2[i]);
        System.out.println();       // Abschluss mit Leerzeile

        // Array s2 ausgeben, mittels Methode
        ausgabe ( s2 );

        // Array s1 nach Array s3 kopieren
        kopiere( s1, s3 );            // Array s3 wird verändert! 
        ausgabe( s3 );

        // neues Array s4 erzeugen, das eine Kopie von s1 ist
        String[] s4 = kopie( s1 );
        ausgabe( s4 );

        // Elemente von s1 verdoppeln
        verdopple( s1 );             // Array s1 wird verändert! 
        ausgabe( s1 );

        // neues Array s5 erzeugen, das die verdoppelten Elemente von s1 enthält
        String[] s5 = verdoppelt( s1 );
        ausgabe( s5 );

    }

    /**
    * Ausgabe aller Elemente eines Arrays.
    */
    private static void ausgabe(String[] s1) {

        for (int i = 0; i < s1.length; i++) 
            System.out.println("[" + i + "]: " + s1[i]);

        System.out.println();               // Abschluss mit Leerzeile
    }

    /**
    * Kopieren eines Arrays.
    * Das Array, das an Stelle von b übergeben wird, wird verändert!
    */
    private static void kopiere(String[] s1, String[] s2) {
        for (int i = 0; i < s1.length; i++) // Kopieren der Werte der Elemente von s1
            s2[i] = s1[i];                  // in die entsprechenden Elemente von s2
    }

    /**
    * Kopieren eines Arrays.
    * Liefert neues Array, das eine Kopie des übergebenen Arrays ist.
    */
    private static String[] kopie(String[] s1) {
        String[] r = new String[s1.length];        // neues Array r derselben Länge wie s1
        
        for (int i = 0; i < s1.length; i++) // Kopieren der Werte der Elemente von s1
            r[i] = s1[i];                   // in die entsprechenden Elemente von r

        return r;                           // r wird als Ergebnis zurückgegeben
    }

    /**
    * Elementweises Verdoppeln eines String-Arrays.
    * Das übergebene Array wird verändert!
    */
    private static void verdopple(String[] s1) {

        for (int i = 0; i < s1.length; i++)  
            s1[i] = s1[i] + " *** " +  s1[i];   // Element i wird "verdoppelt"
    }

    /**
    * Elementweises Verdoppeln eines String-Arrays.
    * Liefert ein neues Array, das die verdoppelten Strings des übergebenen Arrays enthält.
    */
    private static String[] verdoppelt(String[] s1) {
        String[] r = new String[s1.length];     // neues Array derselben Länge wie s1

        for (int i=0; i< s1.length; i++)        // den Elementen von r werden die 
            r[i] = s1[i] + " *** " + s1[i];     // entsprechenden Elemente von s1 "verdoppelt" zugewiesen

        return r;                               // r wird als Ergebnis zurückgegeben
    }

}
