/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Darstellung von Zügen auf einem Schachbrett
 */
public class Schachbrett {
    public static void main(String[] args) {

        // Das 8x8 Spielfeld als Stringarray mit 8 Elementen mit jeweils Länge 8

        String[] spielfeld = new String[8];

        spielfeld[7] = "tsldklst";
        spielfeld[6] = "bbbbbbbb";
        spielfeld[5] = "........";
        spielfeld[4] = "........";
        spielfeld[3] = "........";
        spielfeld[2] = "........";
        spielfeld[1] = "BBBBBBBB";
        spielfeld[0] = "TSLDKLST";

        ausgabe (spielfeld);

        ziehe (spielfeld, "Ba1-a2");
        ausgabe (spielfeld);

        ziehe (spielfeld, "De3-g5");
        ausgabe (spielfeld);

        ziehe (spielfeld, "Bc2-c3");
        ausgabe (spielfeld);

        ziehe (spielfeld, "Dd1-a4");
        ausgabe (spielfeld);

        }

    /**
    *  Führt einen Zug aus, z. B. "De3-g5"
    */
    private static void ziehe(String[] spielfeld, String zug) {

        char figur      = zug.charAt( 0 );                  // die Figur, z. B.             'D' ... Dame
        char vonspalte  = zug.charAt( 1 );                  // Ausgangsfeld Spalte, z. B.   'e'
        int  vonreihe   = ziffer2int( zug.charAt(2) );      // Ausgansfeld Reihe, z.B.       3
        char nachspalte = zug.charAt( 4 );                  // Zielfeld Spalte, z. B.       'g'
        int  nachreihe  = ziffer2int( zug.charAt(5) );      // Zielfeld Reihe, z.B.          5

        System.out.println(zug + ":");

        // Prüfung, ob die Figur auf dem Ausgangsfeld steht
        if ( figur != figurauf( spielfeld, vonspalte, vonreihe )) {

            System.out.println(figurname(figur) + " steht nicht auf " + vonspalte + vonreihe);
            return;
            }

        // ins Ausgangsfeld '.' (leeres Feld) eintragen
        setze( spielfeld, '.' , vonspalte, vonreihe );

        // Figur ins Zielfeld eintragen 
        setze( spielfeld, figur, nachspalte, nachreihe );

        return;
    }

    /**
    * Welche Figur befindet sich auf einem Feld, z. B. 'e', 3  (e3)  ?
    * spielfeld wird nicht verändert
    */
    private static char figurauf(String[] spielfeld, char idspalte, int idreihe) {

        String reihe = spielfeld[ idreihe -1 ];                 // die entsprechende Reihe

        char figur = reihe.charAt( buchstabe2pos(idspalte) );   // das Zeichen an dieser Spaltenposition

        return figur;
    }

    /**
    *  Setze auf ein Feld eine Figur, z. B. nach: 'D' (Dame) nach 'g', 5 (g5)
    *  spielfeld wird verändert
    */
    private static void setze(String[] spielfeld, char figur, char idspalte, int idreihe) {

        String reihe = spielfeld[ idreihe -1 ];                 // die entsprechende Reihe

        char[] zeichenarray = reihe.toCharArray();              // Zeichenarray der Reihe
    
        zeichenarray [ buchstabe2pos(idspalte) ] = figur;       // setze Figur an die Spaltenposition

        spielfeld[ idreihe -1 ] = String.valueOf(zeichenarray); // die veränderte Reihe als String

    }

    /**
    * Liefert die Spaltenposition 0-7 aus der Spaltenbezeichnung a-h
    */
    private static int buchstabe2pos(char z) {
        int pos;

        switch ( z ) {

            case 'a': pos = 0; break;
            case 'b': pos = 1; break;
            case 'c': pos = 2; break;
            case 'd': pos = 3; break;
            case 'e': pos = 4; break;
            case 'f': pos = 5; break;
            case 'g': pos = 6; break;
            case 'h': pos = 7; break;

            default: pos = -1;

        }
        return pos;

    }

    /**
    * Liefert den Zahlenwert einer Ziffer 
    */
    private static int ziffer2int(char z) {
        int i;

        switch ( z ) {

            case '1': i = 1; break;
            case '2': i = 2; break;
            case '3': i = 3; break;
            case '4': i = 4; break;
            case '5': i = 5; break;
            case '6': i = 6; break;
            case '7': i = 7; break;
            case '8': i = 8; break;

            default: i = -1;

        }
        return i;

    }

    /**
    * Liefer den Namen einer Figur aus der Figurkennzeichnung
    */
    private static String figurname(char figur) {
        String name;

        switch ( figur ) {

            case 'B': name = "Bauer(w)";        break;
            case 'T': name = "Turm(w)" ;        break;
            case 'S': name = "Springer(w)";     break;
            case 'L': name = "Läufer(w)";       break;
            case 'D': name = "Dame(w)";         break;
            case 'K': name = "König(w)";        break;

            case 'r': name = "Bauer(s)";        break;
            case 't': name = "Turm(s)" ;        break;
            case 's': name = "Springer(s)";     break;
            case 'l': name = "Läufer(s)";       break;
            case 'd': name = "Dame(s)";         break;
            case 'k': name = "König(s)";        break;

            default: name = "noname";

        }
        return name ;

    }

    /**
    * Ausgabe des Spielfelds
    */
    private static void ausgabe(String[] spielfeld) {
        System.out.println();

        for (int i = 8; i > 0; i--) 
            System.out.println(i+" "+spielfeld[i-1]);
        System.out.println("  abcdefgh");

        System.out.println();
    }

}
