import java.util.Scanner;
/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Rechnen mit Umgekehrt Polnischer Notation (UPN) 
 * mit einem Stack-Speicher: die Ausführung einer Operation 
 * nimmt die zwei obersten Elemente vom Stack, verknüpft 
 * diese, und legt das Ergebnis wieder auf den Stack.
 * z. B. (3+6)/4 = 2:
 *      '3'     legt 3 auf den Stack
 *      '6'     legt 6 auf den Stack
 *      '+'     nimmt 6 und danach 3 vom Stack, addiert 
 *              die beiden, und legt 9 auf den Stack
 *      '4'     legt 4 auf den Stack
 *      '/'     nimmt 4 und danach 9 vom Stack, dividiert
 *              9/4 und legt 2 auf den Stack
 */
public class UPNStack {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        int[] stack;

        stack = emptystack(10);                     // liefert leeren Stack mit 10 Elementen

        while (scanner.hasNext()) {

            if (scanner.hasNextInt()) {

                int zahl = scanner.nextInt();       
    
                if (! offerfirst(stack, zahl) )     // "push" zahl 
                    System.out.println("Stack ist bereits voll");
            }

            else {

                String s = scanner.next();
                char operation = s.charAt(0);       // '+', '-', '*', '/', oder '%'

                int operand2 = pollfirst(stack);    // "pop" liefert den zweiten(!) operanden
                int operand1 = pollfirst(stack);    // "pop" liefert den ersten operanden
                int ergebnis;
                
                switch ( operation) {

                    case '+':   ergebnis = operand1 + operand2;
                    break;

                    case '-':   ergebnis = operand1 - operand2;
                    break;

                    case '*':   ergebnis = operand1 * operand2;
                    break;

                    case '/':   ergebnis = operand1 / operand2;
                    break;

                    case '%':   ergebnis = operand1 % operand2;
                    break;
    
                    default:    System.out.println("keine gültige Operation");
                                ergebnis = -999999;
                }

            System.out.println("=" + ergebnis);

            offerfirst(stack, ergebnis);        // "push" legt Ergebnis auf den Stack
            }

        }   

    }

    /**
    * liefert einen leeren Stack einer bestimmten Kapazität
    */
    private static int[] emptystack(int capacity) { 
        int[] r ;
        r  = new int[capacity + 1];       // + 0. Element!
        return r;
        }

    /**
    * Test auf "empty"
    */
    private static boolean isempty(int[] stack) {
        return (stack[0] == 0);     // aktuelle Größe ist 0
        }

    /**
    * liefert aktuelle Größe des Stacks
    */
    private static int size(int[] stack) {
        return stack[0];
        }

    /**
    * Operation "push" 
    */
    private static boolean offerfirst(int[] stack, int number) {
        int i = stack[0];           // aktuelle Größe

        if (i == stack.length-1)    // Kapazität erreicht
            return false;

        i++;                        // um 1 erhöhen

        stack[i] = number;          // number hinzufügen

        stack[0] = i;
        return true;
    }
        
    /**
    * Operation "pop"
    */
    private static int pollfirst(int[] stack) {
        int i = stack[0];           // aktuelle Größe

        if (i == 0)                 // Stack ist leer!
            return -999999;
        
        int number = stack[i];      // oberstes (erstes) Element

        i--;                        // aktuelle Größe um 1 reduzieren

        stack[0] = i;
        return number;
    }
        
}
