/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Eine Klasse, die einen Termin repräsentiert.
 */
public class Termin {

    // *** Instanzvariablen ***
    // Datum
    private int tag;
    private int monat;
    private int jahr;   

    // Beginnzeit (auf Stunden genau)
    private int beginn; 
    
    // Dauer (in Stunden)
    private int dauer;

    // Zweck 
    private String beschreibung;

    // Folgetermin
    private Termin folge;

    // *** Instanzmethoden ***
    // einen Termin setzen
    public void setze(int j, int m, int t, int s, int d, String b) {
        tag    = t;
        monat  = m;
        jahr   = j;
        beginn = s;
        dauer  = d;
        beschreibung = b;
        }   

    /**
    * Ende des Termins
    */
    public int ende() {
        return beginn + dauer;
        }

    /**
    * Darstellung des Termins als Text
    */
    public String toString() {
        return beschreibung + " am "+ tag + "." + monat + "." + jahr + " von " + beginn + " bis " + ende() + " Uhr";
        }

    /**
    * Gibt es eine Kollision mit einem anderen Termin?
    */
    public boolean kollision(Termin termin2) {
    
        if ( termin2.tag   == tag   &&
             termin2.monat == monat &&
             termin2.jahr  == jahr  &&
             termin2.beginn < ende() && beginn < termin2.ende() )
            return true;
        else
            return false;

        }           

    /**
    * Setze einen Folgetermin 
    */
    public void folgetermin(Termin termin2) {
    
        folge = termin2;
        
        }
        
    /**
    * Die main-Methode zur Ausführung der Klasse
    */
    public static void main(String[] args) {

        Termin termin = new Termin();
        // 17.11.2014, 14 Uhr, 1 Stunde
        termin.setze( 2014, 11, 17, 14, 1, "13. Praxisbesprechung" );
        System.out.println(termin.toString());

        Termin termin2 = new Termin();
        // 17.11.2014, 16 Uhr, 2 Stunden
        termin2.setze( 2014, 11, 17, 17, 2, "Fitness Center" );
        System.out.println( termin2.toString() );

        if (! termin.kollision(termin2) )
            System.out.print("keine ");
        System.out.println("Kollision");

        Termin termin3 = new Termin();
        // 20.11.2014, 17 Uhr, 2 Stunde
        termin3.setze( 2014, 11, 17, 18, 2, "Kochkurs" );
        System.out.println( termin3.toString() );

        if (! termin2.kollision(termin3) )
            System.out.print("keine ");
        System.out.println("Kollision");

        Termin termin4 = new Termin();
        // 20.11.2014, 14 Uhr, 1 Stunde
        termin4.setze( 2014, 11, 20, 14, 1, "14. Praxisbesprechung" );

        // Folgetermin setzen
        termin.folgetermin(termin4);

        // ein weiterer Folgetermin
        Termin termin5 = new Termin();
        // 24.11.2014, 14 Uhr, 1 Stunde
        termin5.setze( 2014, 11, 24, 14, 1, "15. Praxisbesprechung" );
        termin4.folgetermin(termin5);
        
        // einen Termin und alle Folgetermine anzeigen
        for (Termin t = termin; t != null; t = t.folge) 
            System.out.println( t.toString() );
            
    }
}
