import java.util.Scanner;
/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Rechnen mit Umgekehrt Polnischer Notation (UPN) 
 * mit einem Stack-Speicher: die Ausführung einer Operation 
 * nimmt die zwei obersten Elemente vom Stack, verknüpft 
 * diese, und legt das Ergebnis wieder auf den Stack.
 * z. B. (3+6)/4 = 2:
 *      '3'     legt 3 auf den Stack
 *      '6'     legt 6 auf den Stack
 *      '+'     nimmt 6 und danach 3 vom Stack, addiert 
 *              die beiden, und legt 9 auf den Stack
 *      '4'     legt 4 auf den Stack
 *      '/'     nimmt 4 und danach 9 vom Stack, dividiert
 *              9/4 und legt 2 auf den Stack
 */
public class UPNStackOO {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);


        Stack stack = new Stack(10);               // leerer Stack mit 10 Elementen


        while (scanner.hasNext()) {

            if (scanner.hasNextInt()) {

                int zahl = scanner.nextInt();       
    
                if (! stack.offerfirst(zahl) )     // "push" zahl 
                    System.out.println("Stack ist bereits voll");
            }

            else {

                String s = scanner.next();
                char operation = s.charAt(0);       // '+', '-', '*', '/', oder '%'

                int operand2 = stack.pollfirst();    // "pop" liefert den zweiten(!) operanden
                int operand1 = stack.pollfirst();    // "pop" liefert den ersten operanden
                int ergebnis;
                
                switch ( operation) {

                    case '+':   ergebnis = operand1 + operand2;
                    break;

                    case '-':   ergebnis = operand1 - operand2;
                    break;

                    case '*':   ergebnis = operand1 * operand2;
                    break;

                    case '/':   ergebnis = operand1 / operand2;
                    break;

                    case '%':   ergebnis = operand1 % operand2;
                    break;
    
                    default:    System.out.println("keine gültige Operation");
                                ergebnis = -999999;
                }

            System.out.println("=" + ergebnis);

            stack.offerfirst(ergebnis);        // "push" ergebnis 
            }
 
        }   

    }
}
