/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Ein User mit einer Freundesliste
 */
class User {

    private String name;                // Name

    private Friend friendList;          // erster Knoten der Freundesliste

    /**
    * Konstruktor setzt den Namen
    */
    public User(String name) {
        this.name = name;
    }

    /**
    * liefert den Namen
    */
    public String name() {
        return name;
    }

    /**
    * liefert den Beginn (ersten Knoten) der Freundesliste
    */
    public Friend friends() {
        return friendList;
    }

    /**
    * zeigt die Freunde an
    */
    public void showFriends() {
        System.out.print("{ "+name()+": ");

        Friend friend = friendList;
        while (friend != null) {        // Listenende erreicht ?
            User u = friend.who();
            System.out.print(u.name()+" ");

            // nächster Knoten in der Liste
            friend = friend.next();
        }
        System.out.println("}");
    }

    /**
    * Test auf Freundschaft
    */
    public boolean isFriend(User user) {

        Friend friend = friendList;
        while (friend != null) {

            // wenn "user" ein Freund ist
            if (user == friend.who()) return true;

            // nächster Knoten in der Liste
            friend = friend.next();
        }
        return false;
    }

    /**
    * trägt in die Freundesliste ein
    */
    public void addFriend(User user) {

        // wenn "user" noch nicht Freund ist
        if (!isFriend(user)) { 

            // Erzeugen eines neuen Listenknotens, der 
            // vorne in die Liste eingehängt wird
            friendList = new Friend(user, friendList);

            // trage auch "mich" als Freund von "user" ein
            user.addFriend(this);
        }
    }

    /**
    * zeigt gemeinsame Freunde an
    */
    void showCommonFriends(User user) {
        System.out.print("{ "+name()+" & "+user.name()+": ");

        Friend friend = friendList;
        while (friend != null) {

            User f = friend.who();
            // wenn "user" Freund einer "meiner" Freunde ist
            if (f.isFriend(user))
                System.out.print(f.name()+" ");

            // nächster Knoten in der Liste
            friend = friend.next();
        }
        System.out.println("}");
    }

}
