/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Halbaddierer-Klasse 
 */
public class HalfAdderComponent {

    // ein Halbadierer besteht aus 6 Gattern
    private Gate[] gate = new Gate[6];

    public HalfAdderComponent(Gate x, Gate y) {

        // Aufbau des Halbadierers aus den Gattern
        gate[0] = new Gate("NOT", x);               // NOT x
        gate[1] = new Gate("NOT", y);               // NOT y
        gate[2] = new Gate(gate[0], "AND", y);      // (NOT x) AND y
        gate[3] = new Gate(x, "AND", gate[1]);      // x and (NOT y)
        gate[4] = new Gate(gate[2], "OR", gate[3]); // s = ((NOT x) AND y) OR (x and (NOT y))
        gate[5] = new Gate(x, "AND", y);            // c = x AND y  
    }

    // Halbadierer schaltet: Durchführung der Operationen aller Gatter (Reihenfolge!)
    public void operate() {
        for (int i=0; i<gate.length; i++) 
            gate[i].operate();
    }

    // sum-Ausgang
    public Gate getSum() {
        return gate[4];
    }

    // carry-Ausgang
    public Gate getCarry() {
        return gate[5];
    }

}
