/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Halbaddierer mit Array von Gattern
 */
public class HalfAdderV2 {
    public static void main(String[] args) {

        // Eingänge des Halbadierers: (Pseudo-) Gatter ohne Operation
        Gate x  = new Gate();
        Gate y  = new Gate();       
    
        // ein Halbadierer besteht aus 6 Gattern
        Gate[] gate = new Gate[6];
    
        // Aufbau des Halbadierers aus den Gattern
        gate[0] = new Gate("NOT", x);               // NOT x
        gate[1] = new Gate("NOT", y);               // NOT y
        gate[2] = new Gate(gate[0], "AND", y);      // (NOT x) AND y
        gate[3] = new Gate(x, "AND", gate[1]);      // x and (NOT y)
        gate[4] = new Gate(gate[2], "OR", gate[3]); // s = ((NOT x) AND y) OR (x and (NOT y))
        gate[5] = new Gate(x, "AND", y);            // c = x AND y
        
        // Belegung der Eingänge
        x.setValue(true);
        y.setValue(false);
    
        // Halbadierer schaltet: Durchführung der Operationen aller Gatter (Reihenfolge!)
        for (int i=0; i<gate.length; i++) 
            gate[i].operate();
    
        // Ergebnis
        boolean s = gate[4].getValue();             // sum 
        boolean c = gate[5].getValue();             // carry 
    
        System.out.println("sum   = " + s);
        System.out.println("carry = " + c);

    }

}
