import java.util.ArrayList;
import java.util.Iterator;
/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Ein Line-Objekt repräsentiert eine Zeile.
 * Diese wird als eine Liste von Wörtern dargestellt.
 * Ein Wort besteht aus mindestens einem Zeichen und wird als 
 * String-Objekt dargestellt. 
 * Es kommen keine Leerstrings vor.
 * Es kommen nur Zeilen vor, die mindestens ein Wort enthalten.
 */
class Line {
    private ArrayList<String> words;        // die Wörter einer Zeile

    /**
    * Konstruktor erzeugt leere Zeile
    */
    Line() {
        words = new ArrayList<String>();
    }

    /**
    * Fügt ein Wort am Ende einer Zeile an.
    * @param word anzufügendes Wort
    */
    public void addWord(String word) {
        words.add(word);
    }

    /**
    * @return Liefert Anzahl der Wörter
    */
    public int numberOfWords() {
        return words.size();
    }

    /**
    * @return Liefert Iterator über alle Wörter der Zeile
    */
    public Iterator<String> getIterator() {
        return words.iterator();
    }

    /**
    * Ersetzt ein Wort in der Zeile durch ein anderes
    * @param word zu ersetzendes Wort
    * @param newWord ersetzendes Wort
    */
    public void substitute(String word, String newWord) {

        for (int i=0; i < words.size(); i++) {      // über alle Wörter
            if ( word.equals(words.get(i)) )        // Wort gefunden
                words.set(i,newWord);               // Wort ersetzen
        }
    }

    /**
    *  @return liefert einen String mit allen Wörtern der Zeile
    *  mittels for-each-Schleife
    */
    public String toString() {
        String s = "";

        for (String word : words) {  // "for each" Element der Liste words
            s += " " + word;         // word an s anhängen
        }                            // words darf in der Schleife nicht verändert werden!

        return s;
    }

    /**
    *  @return liefert einen String mit allen Wörtern der Zeile
    *  äquivalent zu toString() (s.o.), mittels Iterator-Objekt
    */
    public String toStringIt() {
        String s = "";
        Iterator<String> wIt = words.iterator();
        while (wIt.hasNext()) {
            String word = wIt.next();
            s += " " + word;        // word an s anhängen
        }                           // words sollte in der Schleife nicht verändert werden

        return s;
    }

}
