import java.util.Scanner;
import java.util.Set;
import java.util.Iterator;
/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Textdarstelllung und -manipulation
 */
public class Main {
    public static void main(String[] args) {
                
        Scanner input;
        Scanner parseLine;

        input = new Scanner(System.in);

        Text text = new Text(); 

        /* Aufbau der Struktur (mittels der Klassen Text und Line): */

        while (input.hasNextLine()) {
            String l = input.nextLine();        // Zeile einlesen
            if (l.length()>0) {                 // leere Zeile ?
                Line line = new Line();         // Zeilenobjekt erzeugen
                parseLine = new Scanner(l);     // Zeile in Wörter zerlegen
                while (parseLine.hasNext()) {   
                    String w = parseLine.next();        
                    line.addWord(w);            // Wort zur Zeile hinzufügen
                }   
                text.addLine(line);             // Zeile zum Text hinzufügen
            }
        }

        /* zeilenweise Ausgabe des Texts: */
        System.out.println("** Text: **");
        Iterator<Line> lIt = text.getLineIterator();
        while (lIt.hasNext())  
            System.out.println(lIt.next().toString());

        System.out.println();

        /* Ausgabe der Anzahlen: */
        System.out.println("** Statistik: **");
        System.out.println(text.numberOfLines()+" Zeilen, "+text.numberOfWords()+
            " Wörter ("+text.numberOfUniqueWords()+" unique)");

        System.out.println();

        /* Zählen der Wortvorkommnisse und deren Ausgabe: */
        System.out.println("** Vorkommnisse: **");
        text.calculateWordCounts();
        /* Menge der Keys der HashMap */
        Set<String> keys = text.getWordCounts().keySet();
        for ( String word : keys ) 
            System.out.println(word+" "+ text.getWordCounts().get(word));

        System.out.println();

        /* Ersetzen von "vielleicht" durch "sicher": */
        System.out.println("** Ersetzung: **");
        text.substitute("vielleicht","sicher");     // ändert text !
        /* Ausgabe */
        lIt = text.getLineIterator(); // neuer Iterator, das text verändert wurde
        while (lIt.hasNext())  
            System.out.println(lIt.next().toString());

        System.out.println();

        /* Formatieren auf 20 Zeichen und Ausgabe: */
        System.out.println("** Formatierung: **");
        Text formattedText = text.format(20);
        // Ausgabe
        lIt = formattedText.getLineIterator();  // Iterator über formattedText!
        while (lIt.hasNext())  
            System.out.println(lIt.next().toString());

    }
}
