/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Klasse, die einen Kreis mit Mittelpunkt, Radius
 * und einer Umrandung repräsentiert.
 * Die Umrandung hat eine bestimmte Breite.
 * Unterklasse der Klasse Circle.
 */
public class BorderCircle extends Circle {
    // Kreis mit Umrandung einer bestimmten Breite: Unterklasse von Circle 
    // Variable der Oberklasse Circle werden geerbt 
    
    double width;   // zusätzliche Variable für Umrandungsbreite

    // Konstruktor
    public BorderCircle(double x, double y, double r, double width) {
        super(x, y, r); // Aufruf des Konstruktors der Oberklasse
        this.width = width;
    }

    // Konstruktor kopiert Kreis c
    public BorderCircle(Circle c, double width) {
        super(c);       // Aufruf des Konstruktors der Oberklasse 
        this.width = width;
    }
    
    // Umfang-Methode von Circle wird überschrieben
    public double circumference() { 
        return 2.0 * (r + width) * PI ; 
    }

    // Flaeche-Methode von Circle wird überschrieben
    public double area() {  
        return (r + width)*(r + width) * PI ; 
    }

    // Stringdarstellung der Werte wird überschrieben
    public String values() { 
        // Verwendung der values()-Methode der Oberklasse 
        return super.values()+ "+" + width ; 
    } 

    // Stringdarstellung des Kreises wird überschrieben
    public String toString() { 
        return "BorderCircle[" + this.values() + "]" ;
    } 

}
