/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Klasse, die einen Kreis mit Mittelpunkt und 
 * Radius repräsentiert.
 */
public class Circle {

    static final double PI = 3.14159265358979323846;

    double x, y;   // Koordinaten des Mittelpunktes
    double r;      // Radius

    // Konstruktor, der alle Instanzvariablen setzt
    public Circle(double x, double y, double r) {
        this.x = x;
        this.y = y;
        this.r = r;
    }

    // Konstruktor für Kreis mit Mittelpunkt (0,0)
    public Circle(double r) { 
        // x = 0.0;     Default-Wert für float
        // y = 0.0;     ""
        this.r = r; 
    }

    /*
    // alternativ:
    public Circle(double r) { 
        // x = 0.0; 
        // y = 0.0; 
        this(0.0, 0.0, r);
    }
    */

    // Konstruktor für Einheitskreis 
    public Circle() { 
        // x = 0.0;     // Default-Wert für float
        // y = 0.0;     // ""
        this.r = 1.0; 
    }   

    /*
    // alternativ:
    public Circle(double r) { 
        this(1.0);
    }
    */

    // Kopierkonstruktor
    public Circle(Circle c) { 
        this.x = c.x; 
        this.y = c.y; 
        this.r = c.r; 
    }

    // Kreisumfang
    public double circumference() { 
        return 2.0 * r * PI ; 
    }

    // Fläche 
    public double area() {  
        return r*r * PI ; 
    }

    // Stringdarstellung der Werte der Instanzvariablen
    public String values() { 
        return x + "/" + y + "," + r ;
    } 

    // Stringdarstellung des Kreis-Objekts
    public String toString() { 
        return "Circle[" + values() + "]" ;
    } 

}
