/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Kreis-Beispiele (ii)
 * basierend auf David Flanagan, Java in a Nutshell, OReilly
 */
public class Main {
    public static void main(String argv[]) {

        // Erzeugen eines Zeichenfensters

        DrawWindow dw = new DrawWindow();

        /* ein Array mit 3 Elementen vom Typ 'abstrakte Klasse Shape' */
        Shape[] shapes = new Shape[3];              

        // Erzeugung der Elemente

        shapes[0] = new Circle(1.0);            
        shapes[1] = new Rectangle(2.0, 3.0);
        shapes[2] = new Rectangle(4.0, 5.0);

        // Berechnung der Gesamtfläche dieser Figuren 

        double totalArea = 0.0;

        for (int i = 0; i < shapes.length; i++) {

            // Aufruf der entsprechenden Flächenformel, je nachdem,
            // ob es sich um Circle oder Rectangle handelt

            totalArea += shapes[i].area();  // dynamisches Binden von area()

        }
        
        System.out.println("total area: " + totalArea);

        /* ein Array mit 3 Elementen vom Typ 'Interface Drawable' */
        Drawable[] drawables = new Drawable[3];

        // Erzeugung der Elemente

        DrawableCircle c1 = new DrawableCircle(2.0);
        c1.setColors("red","green");

        DrawableRectangle r1 = new DrawableRectangle(3.0, 4.0);
        r1.setColors("blue","yellow");

        DrawableRectangle r2 = new DrawableRectangle(5.0, 6.0);
        r2.setColors("orange","cyan");

        // dies sind sowohl Shape- als auch Drawable-Objekte:

        shapes[0]    = c1;
        drawables[0] = c1;

        shapes[1]    = r1;
        drawables[1] = r1;
    
        shapes[2]    = r2;
        drawables[2] = r2;


        // Berechnung des Gesamtumfangs und Zeichnen dieser Figuren

        double totalCircumference = 0.0;

        for(int i = 0; i < drawables.length; i++) {

            // Shape-Objekte haben circumference()-Methode
            totalCircumference += shapes[i].circumference();    // dyn. Binden

            // Drawable-Objekte haben setPosition()-Methode
            drawables[i].setPosition(i*2.0, i*4.0);             // dyn. Binden
            // Drawable-Objekte haben draw()-Methode
            drawables[i].draw(dw);                              // dyn. Binden

        }


        System.out.println("total circumference: " + totalCircumference);
    }
    
}
