/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Abstrakte Klasse, die eine Figur repräsentiert.
 * Von dieser Klasse werden keine Instanzen erzeugt, sondern 
 * nur von ihren Unterklassen (z. B. Kreis, Rechteck).
 */
public abstract class Shape {

    // Shape-Objekte haben Methoden für Umfang und Fläche, deren 
    // Implementierung jedoch von der konkreten Figur abhängt. Daher
    // werden sie hier abstrakt deklariert.

    // Abstrakte Methoden haben keine Implementierung und müssen in 
    // Unterklassen überschrieben und implementiert werden.

    public abstract double area();              // Flächenformel

    public abstract double circumference();     // Umfangsformel

}
