package sensorpoint;

import java.util.Collection; 
import java.util.Set; 
import java.util.Map; 
import java.util.HashMap; 
import java.util.Iterator; 
/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Punkt mit Sensoren
 */
import point.Point;         // erbt von Point
import sensor.Sensor;       // benutzt (nur) abstrakten Sensor
public class SensorPoint extends Point {

    // Menge der Sensoren als Map: Sensorname -> Sensorobjekt
    private Map<String,Sensor> sensors;

    public SensorPoint(double l, double b, double z) {
        super(l,b,z);
        sensors = new HashMap<String,Sensor>();
    }
    
    // Sensor anfügen
    public void addSensor(Sensor s) {
        sensors.put(s.getName(),s);
    }

    // Namen aller Sensoren auflisten
    public void listSensors() {
        Set<String> names = sensors.keySet();
        Iterator<String> sit = names.iterator();
        String s;
        System.out.print("all sensors:");
        while (sit.hasNext()) {
            s = sit.next();
            System.out.print(" " + s);
        }
        System.out.println();
    }

    // Variante mittels for-each    
    public void listSensorsV2() {
        System.out.print("all sensors:");
        for (String s: sensors.keySet()) 
            System.out.print(" " + s);
        System.out.println();
    }

    // einen Sensor auslesen
    public void readSensor(String s) {
        sensors.get(s).read();
    }

    // alle Daten des Sensorpunkts ausgeben
    public void print() {
        System.out.println("point at position "+ this +":");
        Collection<Sensor> sensors = this.sensors.values();
        Iterator<Sensor> sit = sensors.iterator();
        Sensor s;
        while (sit.hasNext()) {
            s = sit.next();
            System.out.println("    <" + s.getName() + ", " + 
                ( s.getDate() !=null ? s.getDate() : "" ) + ", " + 
                s.getValue() + ">");
        }
    }

    // Variante
    public void printV2() {
        System.out.println("point at position "+ this +":");
        for (Sensor s: sensors.values())
            System.out.println("    <" + s.getName() + ", " + 
                ( s.getDate() !=null ? s.getDate() : "" ) + ", " + 
                s.getValue() + ">"); 
    }

}
