package sensorpoint;

import java.util.Collection; 
import java.util.Set; 
import java.util.Map; 
import java.util.HashMap; 
import java.util.Iterator; 
import java.util.Date; 
/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Punkt mit Sensoren
 */
import point.Point;         // erbt von Point
import sensor.Sensor;       // benutzt (nur) abstrakten Sensor
public class SensorPoint extends Point implements Sensor {

    private final String name;  // der Name des Sensors
    private Date date;          // der Zeitpunkt des letztmaligen Auslesens mittels read()
    private double value;       // der zuletzt mittels readValue() ausgelesene Wert: 

    public SensorPoint(double l, double b, double h, String name) {
        super(l,b,h);
        this.name = name;
    }

    // liefert den Namen    
    public String getName() {
        return name;
    }

    // Auslesen des Sensors
    public void read() {
        date  = new Date();      // aktuelle Zeit speichern
        value = Math.random()*100.0-50.0;
    }
    
    // liefert den Zeitpunkt des letzten Auslesens
    public Date getDate() {
        return date;
    }

    // liefert den zuletzt ausgelesenen Wert
    public double getValue() {
        return value;
    }

    // Formatierung als String
    public String toString() {
        return name + " " + super.toString() + ", " + date + ", " + value;
    }

}
