/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Digitale Schaltungen
 * Volladdierer
 */
public class FullAdder implements Component {

    // die Teilkomponenten des Volladierers
    private Component[] comp = new Component[3];

    // ein Volladierer besteht aus zwei Halbaddiern und einem OR-Gatter
    private HalfAdder ha1;
    private HalfAdder ha2;
    private Gate or;

    public FullAdder(Signal x, Signal y, Signal cIn) {

        // Aufbau des Volladdierers aus Teilkomponenten
        ha1  = new HalfAdder(x, y);                     // Half Adder 1
        ha2  = new HalfAdder(ha1.getSum(), cIn);        // Half Adder 2
        or   = new Or(ha1.getCarry(), ha2.getCarry());  // OR

        // Halbaddierer und Gatter sind Component-Objekte
        comp[0] = ha1;
        comp[1] = ha2;
        comp[2] = or;
    }

    // Durchführung der Operationen aller Komponenten, in dieser Reihenfolge
    public void operate() {
        for (int i=0; i<comp.length; i++) 
            comp[i].operate();
    }

    // Ausgang Summe des Volladdierers
    public Signal getSum() {
        return ha2.getSum();
    }

    // Ausgang Übertrag des Volladdierers
    public Signal getCarryOut() {
        return or.out();
    }

}
