/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Digitale Schaltungen
 * Halbaddierer
 */
public class HalfAdder implements Component {

    // ein Halbadierer besteht aus 6 Gattern
    private Gate[] gate = new Gate[6];

    public HalfAdder(Signal x, Signal y) {

        // Aufbau des Halbadierers aus den Gattern
        gate[0] = new Not(x);                           // NOT x
        gate[1] = new Not(y);                           // NOT y
        gate[2] = new And(gate[0].out(), y);            // (NOT x) AND y
        gate[3] = new And(x, gate[1].out());            // x and (NOT y)
        gate[4] = new Or(gate[2].out(), gate[3].out()); // s = ((NOT x) AND y) OR (x and (NOT y))
        gate[5] = new And(x, y);                        // c = x AND y  
    }

    // Halbadierer schaltet: Durchführung der Operationen aller Gatter (Reihenfolge!)
    public void operate() {
        for (int i=0; i<gate.length; i++) 
            gate[i].operate();
    }

    // Ausgang Summe des Halbaddierers    
    public Signal getSum() {
        return gate[4].out();
    }

    // Ausgang Übertrag des Halbaddierers 
    public Signal getCarry() {
        return gate[5].out();
    }

}
