/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Digitale Schaltungen
 * Zusammengesetzte Komponente
 * Eine zusammengesetzte Komponenten ist eine Komponente, die aus 
 * Teilkomponenten besteht.
 */
public abstract class CompoundComponent implements Component {

    private Component[] comp;       // die einzelnen Teilkomponenten

    static int n;                   // Anzahl der CompoundComponent-Objekte 
                                    // (ohne Objekte von Unterklassen)
    private int i;                  // zählt die Teilkomponenten, die hinzugefügt werden
                                    // (in Unterklassen nicht benötigt)
    public abstract int size();     // Anzahl der Teilkomponenten (in Unterklassen definiert)

    // Konstruktor (in Unterklassen aufgerufen)
    public CompoundComponent() {
        comp = new Component[size()];
        n++;     // Zählen der Instanzen von CompoundComponent
    }

    // Hinzufügen einer Komponente
    void addComponent(Component c) {
        comp[this.i++] = c;
    }

    // Zugriff auf eine Komponente
    Component getComponent(int i) {
        return comp[i];
    }

    // Zusammengesetzte Komponente schaltet = 
    // Ausführung  der Operationen der Teilkomponenten
    public void operate() {
        for (int i=0; i<comp.length; i++) 
            comp[i].operate();

        // for (Component c : comp)
        //  c.operate();
    }

}
