/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Digitale Schaltungen
 * VollAddierer als CompoundComponent: operate() wird 
 * von CompoundComponent geerbt
 */
public class FullAdder extends CompoundComponent {

    // keine Instanvariablen; comp von CompoundComponent vererbt

    public FullAdder(Signal x, Signal y, Signal cIn) {

        super();

        // Aufbau des Volladdierers aus Teilkomponenten
        HalfAdder ha1  = new HalfAdder(x, y);                     // Half Adder 1
        HalfAdder ha2  = new HalfAdder(ha1.getSum(), cIn);        // Half Adder 2
        Gate or        = new Or(ha1.getCarry(), ha2.getCarry());  // OR

        // Hinzufügen der Teilkomponenten
        addComponent(ha1);
        addComponent(ha2);
        addComponent(or);
    }

    // Ausgang Summe des Volladdierers
    public Signal getSum() {
        return ((HalfAdder)getComponent(1)).getSum();
    }

    // Ausgang Übertrag des Volladdierers
    public Signal getCarryOut() {
        return ((Gate)getComponent(2)).out();
    }

    // Volladdierer besteht aus 3 Teilkomponenten
    public int size() {
        return 3;
    }

}
