/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Digitale Schaltungen
 * Halbaddierer als CompoundComponent: operate() wird 
 * von CompoundComponent geerbt
 */
public class HalfAdder extends CompoundComponent {

    // keine Instanvariablen; comp von CompoundComponent vererbt

    public HalfAdder(Signal x, Signal y) {

        super(); 

        // ein Halbadierer besteht aus 6 Gattern
        Gate[] gate = new Gate[size()];

        // Aufbau des Halbadierers aus den Gattern
        gate[0] = new Not(x);                           // NOT x
        gate[1] = new Not(y);                           // NOT y
        gate[2] = new And(gate[0].out(), y);            // (NOT x) AND y
        gate[3] = new And(x, gate[1].out());            // x and (NOT y)
        gate[4] = new Or(gate[2].out(), gate[3].out()); // s = ((NOT x) AND y) OR (x and (NOT y))
        gate[5] = new And(x, y);                        // c = x AND y

        // Hinzufügen der Gatter
        for (int i=0; i<gate.length; i++)
            addComponent(gate[i]); 

        // for (Gate g : gate)
        //  addComponent(g); 
    }

    // Ausgang Summe des Halbaddierers  
    public Signal getSum() {
        return ((Gate)getComponent(4)).out();
    }

    // Ausgang Übertrag des Halbaddierers
    public Signal getCarry() {
        return ((Gate)getComponent(5)).out();
    }

    // Halbaddierer besteht aus 6 Teilkomponenten (Gattern)
    public int size() {
        return 6;
    }

}
