/** 
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 */
abstract class ForeignArticle extends Article {

    ForeignArticle(String name) {
        super(name);                            // Konstruktor von Article
    }

    ForeignArticle(String name, double price) { // price in anderer Währung angegeben
        // Konstruktor super(name,price) von Article wird nicht aufgerufen
        this(name);
        setPrice(price);                        // this.setPrice (nicht von Article)
    }

    public abstract String currencySymbol();    // in Unterklassen definiert

    public abstract double exchangeRate();      // in Unterklassen definiert

    protected void setPrice(double price) {     // überschreibt setPrice von Article
                                                // price in anderer Währung angegeben
        super.setPrice( price/exchangeRate() ); // Umrechnung auf Euro und Speicherung
    }

    public String format() {                    
        return super.format() +                 // ergänzt format von Article
            " (" + currencySymbol() + " " +  
            String.format( "%8.2f", getPrice()*exchangeRate() ) + ")";
    }

}
